Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/Automaton.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/Automaton.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/Automaton.cs	(revision 14106)
@@ -392,6 +392,4 @@
         writer.WriteLine("digraph {");
         // writer.WriteLine("rankdir=LR");
-        int[] fs;
-        int nFs;
         for (int s = StartState; s < stateNames.Count; s++) {
           for (int i = 0; i < followStates[s].Count; i++) {
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/Disassembler.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/Disassembler.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/Disassembler.cs	(revision 14106)
@@ -38,5 +38,7 @@
           case (byte)OpCodes.LoadVar:
           {
+#pragma warning disable 0675
               short arg = (short)(((short)code[pc] << 8) | (short)code[pc + 1]);
+#pragma warning restore 0675
               pc += 2;
             sb.AppendFormat(" var{0} ", arg); break;
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/ExpressionEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/ExpressionEvaluator.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/ExpressionEvaluator.cs	(revision 14106)
@@ -512,5 +512,7 @@
       s = 0;
       if (op == (byte)OpCodes.LoadVar) {
+#pragma warning disable 0675
         s = (short)(((short)code[pc] << 8) | (short)code[pc + 1]);
+#pragma warning restore 0675
         pc += 2;
       }
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/SymbolicExpressionGenerator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/SymbolicExpressionGenerator.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/MctsSymbolicRegression/SymbolicExpressionGenerator.cs	(revision 14106)
@@ -176,5 +176,7 @@
       s = 0;
       if (op == OpCodes.LoadVar) {
+#pragma warning disable 0675
         s = (short)(((short)code[pc] << 8) | (short)code[pc + 1]);
+#pragma warning restore 0675
         pc += 2;
       }
Index: /trunk/sources/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs	(revision 14106)
@@ -205,6 +205,6 @@
         Parameters.Add(new FixedValueParameter<BoolValue>("ReevaluateElites", "Flag to determine if elite individuals should be reevaluated (i.e., if stochastic fitness functions are used.)", (BoolValue)new BoolValue(false).AsReadOnly()) { Hidden = true });
       }
+#pragma warning disable 0618
       if (Parameters.ContainsKey("SimilarityCalculator") && Parameters["SimilarityCalculator"] is IConstrainedValueParameter<ISingleObjectiveSolutionSimilarityCalculator>) {
-#pragma warning disable 0618
         var oldParameter = (IConstrainedValueParameter<ISingleObjectiveSolutionSimilarityCalculator>)Parameters["SimilarityCalculator"];
 #pragma warning restore 0618
Index: /trunk/sources/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs	(revision 14106)
@@ -162,6 +162,6 @@
       // BackwardsCompatibility3.3
       #region Backwards compatible code, remove with 3.4
+#pragma warning disable 0618
       if (Parameters.ContainsKey("SimilarityCalculator") && Parameters["SimilarityCalculator"] is IConstrainedValueParameter<ISingleObjectiveSolutionSimilarityCalculator>) {
-#pragma warning disable 0618
         var oldParameter = (IConstrainedValueParameter<ISingleObjectiveSolutionSimilarityCalculator>)Parameters["SimilarityCalculator"];
 #pragma warning restore 0618
Index: /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 14106)
@@ -537,5 +537,5 @@
     }
 
-    private void dataGridView_KeyDown(object sender, KeyEventArgs e) {
+    protected override void dataGridView_KeyDown(object sender, KeyEventArgs e) {
       var selectedRows = dataGridView.SelectedRows;
       var selectedCells = dataGridView.SelectedCells;
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/ConstantModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/ConstantModel.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/ConstantModel.cs	(revision 14106)
@@ -97,5 +97,7 @@
     }
 
+#pragma warning disable 0067
     public event EventHandler ValueChanged;
+#pragma warning restore 0067
     #endregion
 
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ConstantRegressionModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ConstantRegressionModel.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ConstantRegressionModel.cs	(revision 14106)
@@ -85,5 +85,7 @@
     }
 
+#pragma warning disable 0067
     public event EventHandler ValueChanged;
+#pragma warning restore 0067
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Problems.PTSP/3.3/Moves/TwoPointFiveOpt/TwoPointFiveMove.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.PTSP/3.3/Moves/TwoPointFiveOpt/TwoPointFiveMove.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Problems.PTSP/3.3/Moves/TwoPointFiveOpt/TwoPointFiveMove.cs	(revision 14106)
@@ -30,11 +30,11 @@
   public sealed class TwoPointFiveMove : Item {
     [Storable]
-    public int Index1 { get; protected set; }
+    public int Index1 { get; private set; }
     [Storable]
-    public int Index2 { get; protected set; }
+    public int Index2 { get; private set; }
     [Storable]
-    public Permutation Permutation { get; protected set; }
+    public Permutation Permutation { get; private set; }
     [Storable]
-    public bool IsInvert { get; protected set; }
+    public bool IsInvert { get; private set; }
 
     [StorableConstructor]
Index: /trunk/sources/HeuristicLab.Problems.QuadraticAssignment/3.3/Analyzers/QAPPopulationDiversityAnalyzer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.QuadraticAssignment/3.3/Analyzers/QAPPopulationDiversityAnalyzer.cs	(revision 14105)
+++ /trunk/sources/HeuristicLab.Problems.QuadraticAssignment/3.3/Analyzers/QAPPopulationDiversityAnalyzer.cs	(revision 14106)
@@ -34,5 +34,7 @@
   [Item("QAPPopulationDiversityAnalyzer", "An operator for analyzing the diversity of solutions of Quadratic Assignment Problems regarding their structural identity (number of equal facilty->location assignments).")]
   [StorableClass]
+#pragma warning disable 0612
   public sealed class QAPPopulationDiversityAnalyzer : PopulationDiversityAnalyzer<Permutation> {
+#pragma warning restore 0612
     public IValueParameter<BoolValue> UsePhenotypeSimilarityParameter {
       get { return (IValueParameter<BoolValue>)Parameters["UsePhenotypeSimilarity"]; }