Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/HypervolumeAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/HypervolumeAnalyzer.cs	(revision 14107)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/HypervolumeAnalyzer.cs	(revision 14108)
@@ -50,5 +50,6 @@
 
     [StorableConstructor]
-    protected HypervolumeAnalyzer(bool deserializing) : base(deserializing) {
+    protected HypervolumeAnalyzer(bool deserializing)
+      : base(deserializing) {
     }
 
@@ -87,5 +88,5 @@
       double hv = Hypervolume.Calculate(front, referencePoint.ToArray(), testFunction.Maximization(objectives));
 
-      if (!double.IsNaN(hv) || best < hv) {
+      if (hv > best) {
         best = hv;
       }
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs	(revision 14107)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs	(revision 14108)
@@ -32,5 +32,5 @@
   [Item("InvertedGenerationalDistanceAnalyzer", "The inverted generational distance between the current and the best known front (see Multi-Objective Performance Metrics - Shodhganga for more information)")]
   public class InvertedGenerationalDistanceAnalyzer : MOTFAnalyzer {
-
+    public override bool EnabledByDefault { get { return false; } }
 
     private IFixedValueParameter<DoubleValue> DampeningParameter {
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/MOTFAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/MOTFAnalyzer.cs	(revision 14107)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Analyzers/MOTFAnalyzer.cs	(revision 14108)
@@ -33,5 +33,5 @@
   [StorableClass]
   public abstract class MOTFAnalyzer : SingleSuccessorOperator, IMultiObjectiveTestFunctionAnalyzer {
-    public bool EnabledByDefault { get { return true; } }
+    public virtual bool EnabledByDefault { get { return true; } }
 
     public IScopeTreeLookupParameter<DoubleArray> QualitiesParameter {
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Calculators/Spacing.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Calculators/Spacing.cs	(revision 14107)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Calculators/Spacing.cs	(revision 14108)
@@ -37,8 +37,10 @@
       if (!front.Any()) throw new ArgumentException("Front must  not be empty.");
 
-      List<double> d = new List<double>();
-      foreach (double[] r in front) {
+      var points = front.ToList();
+      var d = new List<double>();
+
+      foreach (double[] r in points) {
         var point = r;
-        var otherPoints = front.Where(p => p != point).DefaultIfEmpty(point);
+        var otherPoints = points.Where(p => p != point).DefaultIfEmpty(point);
         double dist = Utilities.MinimumDistance(point, otherPoints);
         d.Add(dist);
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Plugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Plugin.cs.frame	(revision 14107)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Plugin.cs.frame	(revision 14108)
@@ -27,5 +27,4 @@
   [PluginDependency("HeuristicLab.Collections", "3.3")] 
   [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]  
   [PluginDependency("HeuristicLab.Data", "3.3")]
Index: /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Views/MOFrontScatterPlotView.cs
===================================================================
--- /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Views/MOFrontScatterPlotView.cs	(revision 14107)
+++ /branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/HeuristicLab.Problems.MultiObjectiveTestFunctions/3.3/Views/MOFrontScatterPlotView.cs	(revision 14108)
@@ -20,5 +20,4 @@
 #endregion
 using System;
-using System.Data;
 using System.Drawing;
 using System.Linq;
@@ -47,5 +46,5 @@
 
     public MOQualitiesScatterPlotView()
-        : base() {
+      : base() {
       InitializeComponent();
 
@@ -57,4 +56,5 @@
       this.chart.TextAntiAliasingQuality = TextAntiAliasingQuality.High;
       this.chart.AxisViewChanged += new EventHandler<System.Windows.Forms.DataVisualization.Charting.ViewEventArgs>(chart_AxisViewChanged);
+      this.chart.GetToolTipText += new System.EventHandler<ToolTipEventArgs>(this.Chart_GetToolTipText);
 
       //configure axis 
@@ -72,13 +72,4 @@
     }
 
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      this.chart.GetToolTipText += new System.EventHandler<ToolTipEventArgs>(this.Chart_GetToolTipText);
-    }
-
-    protected override void DeregisterContentEvents() {
-      base.DeregisterContentEvents();
-      this.chart.GetToolTipText -= new System.EventHandler<ToolTipEventArgs>(this.Chart_GetToolTipText);
-    }
 
     private void Chart_GetToolTipText(object sender, ToolTipEventArgs e) {