Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Friedman/FriedmanRandomFunction.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Friedman/FriedmanRandomFunction.cs	(revision 14109)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Friedman/FriedmanRandomFunction.cs	(revision 14110)
@@ -29,10 +29,10 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class FriedmanRandomFunction : ArtificialRegressionDataDescriptor {
-    private int nTrainingSamples;
-    private int nTestSamples;
+    private readonly int nTrainingSamples;
+    private readonly int nTestSamples;
 
-    private int numberOfFeatures;
-    private double noiseRatio;
-    private IRandom random;
+    private readonly int numberOfFeatures;
+    private readonly double noiseRatio;
+    private readonly IRandom random;
 
     public override string Name { get { return string.Format("FriedmanRandomFunction-{0:0%} ({1} dim)", noiseRatio, numberOfFeatures); } }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Friedman/FriedmanRandomFunctionInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Friedman/FriedmanRandomFunctionInstanceProvider.cs	(revision 14109)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Friedman/FriedmanRandomFunctionInstanceProvider.cs	(revision 14110)
@@ -22,5 +22,5 @@
 using System;
 using System.Collections.Generic;
-using System.Linq;                                                         
+using System.Linq;
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Random;
@@ -53,20 +53,8 @@
 
     public override IRegressionProblemData LoadData(IDataDescriptor descriptor) {
-      var varNetwork = descriptor as FriedmanRandomFunction;
-      if (varNetwork == null) throw new ArgumentException("FriedmanRandomFunctionInstanceProvider expects an FriedmanRandomFunction data descriptor.");
+      var frfDescriptor = descriptor as FriedmanRandomFunction;
+      if (frfDescriptor == null) throw new ArgumentException("FriedmanRandomFunctionInstanceProvider expects an FriedmanRandomFunction data descriptor.");
       // base call generates a regression problem data
-      var regProblemData = base.LoadData(varNetwork);
-      var problemData =
-        new RegressionProblemData(
-          regProblemData.Dataset, regProblemData.AllowedInputVariables, regProblemData.TargetVariable);
-
-      // copy values from regProblemData to feature selection problem data
-      problemData.Name = regProblemData.Name;
-      problemData.Description = regProblemData.Description;
-      problemData.TrainingPartition.Start = regProblemData.TrainingPartition.Start;
-      problemData.TrainingPartition.End = regProblemData.TrainingPartition.End;
-      problemData.TestPartition.Start = regProblemData.TestPartition.Start;
-      problemData.TestPartition.End = regProblemData.TestPartition.End;
-
+      var problemData = base.LoadData(frfDescriptor);
       return problemData;
     }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/VariableNetworks/VariableNetwork.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/VariableNetworks/VariableNetwork.cs	(revision 14109)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/VariableNetworks/VariableNetwork.cs	(revision 14110)
@@ -23,6 +23,4 @@
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Windows.Forms;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -87,10 +85,8 @@
 
     protected override List<List<double>> GenerateValues() {
-      // var shuffledIdx = Enumerable.Range(0, numberOfFeatures).Shuffle(random).ToList();
-
       // variable names are shuffled in the beginning (and sorted at the end)
       variableNames = variableNames.Shuffle(random).ToArray();
 
-      // a third of all variables are independen vars
+      // a third of all variables are independent vars
       List<List<double>> lvl0 = new List<List<double>>();
       int numLvl0 = (int)Math.Ceiling(numberOfFeatures * 0.33);
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/VariableNetworks/VariableNetworkInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/VariableNetworks/VariableNetworkInstanceProvider.cs	(revision 14109)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/VariableNetworks/VariableNetworkInstanceProvider.cs	(revision 14110)
@@ -22,5 +22,5 @@
 using System;
 using System.Collections.Generic;
-using System.Linq;                                                         
+using System.Linq;
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Random;
@@ -56,17 +56,6 @@
       if (varNetwork == null) throw new ArgumentException("VariableNetworkInstanceProvider expects an VariableNetwork data descriptor.");
       // base call generates a regression problem data
-      var regProblemData = base.LoadData(varNetwork);
-      var problemData =
-        new RegressionProblemData(
-          regProblemData.Dataset, regProblemData.AllowedInputVariables, regProblemData.TargetVariable);
-
-      // copy values from regProblemData to feature selection problem data
-      problemData.Name = regProblemData.Name;
+      var problemData = base.LoadData(varNetwork);
       problemData.Description = varNetwork.Description + Environment.NewLine + varNetwork.NetworkDefinition;
-      problemData.TrainingPartition.Start = regProblemData.TrainingPartition.Start;
-      problemData.TrainingPartition.End = regProblemData.TrainingPartition.End;
-      problemData.TestPartition.Start = regProblemData.TestPartition.Start;
-      problemData.TestPartition.End = regProblemData.TestPartition.End;
-
       return problemData;
     }